%define oname pike
%define moduledir %_libdir/%oname/%version
%define tarname Pike-v%version
%define major 7.6

%def_without pcre

Summary: Interpreted, high-level, object oriented language
Name: pike7.6
Version: 7.6.112
Release: alt4.1
License: GPL
Group: Development/Other
Url: http://pike.ida.liu.se/
Source: http://pike.ida.liu.se/pub/pike/all/7.6.112/%tarname.tar.gz
Source2: %name-alternatives.tar
Source3: %oname-manual.tar
Patch: %name-mandir-fix.patch
Patch1: %oname-cvs-build.patch
Patch2: 10_misplaced_MAXPATHLEN.patch
Patch3: 12_perl_init.patch
Packager: Boris Savelev <boris@altlinux.org>

# Automatically added by buildreq on Mon Feb 16 2009
BuildRequires: bzlib-devel fpc-utils gnome-libs-devel imake
BuildRequires: java-1.6.0-sun-jdbc java-devel libGL-devel
BuildRequires: libMySQL-devel libSDL-devel libSDL_mixer-devel
BuildRequires: libXt-devel libcom_err-devel libfftw-devel
BuildRequires: libfreetds-devel libgdbm-devel libgio-devel
BuildRequires: libgmp-devel libgtk+2-common-devel libkrb5-devel
BuildRequires: libnettle-devel
BuildRequires: librsvg-devel libsane-devel libunixODBC-devel
BuildRequires: mysql-connector-odbc nasm perl-devel postgresql-devel
BuildRequires: slocate tcl-devel unixODBC-gui-qt valgrind-devel xorg-cf-files
%if_with pcre
BuildRequires: libpcre-devel
%endif

Provides: pike = %version-%release
Requires: pike-common

%description
Pike is easily learned, and just as easily used programming language
to develop powerful applications. Pike is designed to be useful and
powerful. As the syntax of Pike is similar to that of C, most
programmers will find it easy to use. As Pike is a high-level,
interpreted and modular object-oriented language, powerful
applications can be rapidly developed. Pike has evolved rather than
been designed. The changes to Pike that have been made have been
guided by its users' needs. In general, the better you get to know
Pike, the more you will appreciate it, from a users perspective.

%package postgres
Summary: Postgres pike module
Group: Development/Other
Requires: %name = %version-%release

%description postgres
This Pike module provides access to Postgres databases.

%package mysql
Summary: MySQL pike module
Group: Development/Other
Requires: %name = %version-%release
%description mysql
This Pike module provides access to MySQL databases.

%package image
Summary: Image pike module
Group: Development/Other
Requires: %name = %version-%release

%description image
This module provides many powerful image processing functions to Pike
programs. Handles GIF, JPEG and PNM.

%package gdbm
Summary: gdb pike module
Group: Development/Other
Requires: %name = %version-%release

%description gdbm
This Pike module provides access to gdbm databases.

%package bzip2
Summary: bzip2 pike module
Group: Development/Other
Requires: %name = %version-%release

%description bzip2
This Pike module provides access to bzip2 compression.

%package GL
Summary: GL pike module
Group: Development/Other
Requires: %name = %version-%release

%description GL
This Pike module provides access to OpenGL functions.

%package gtk
Summary: gtk pike module
Group: Development/Other
Requires: %name = %version-%release

%description gtk
This Pike module provides access to GTK+ functions.

%package GLUT
Summary: GLUT pike module
Group: Development/Other
Requires: %name = %version-%release

%description GLUT
This Pike module provides access to GLUT OpenGL functions.

%package odbc
Summary: ODBC pike module
Group: Development/Other
Requires: %name = %version-%release

%description odbc
This Pike module provides access to databases through ODBC driver.

%package zlib
Summary: zlib pike module
Group: Development/Other
Requires: %name = %version-%release

%description zlib
This Pike module provides access to zlib compression functions.

%package sdl
Summary: sdl pike module
Group: Development/Other
Requires: %name = %version-%release

%description sdl
This Pike module provides access to sdl functions.

%package sane
Summary: sane pike module
Group: Development/Other
Requires: %name = %version-%release

%description sane
This Pike module provides access to libsane functions.

%package nettle
Summary: nettle pike module
Group: Development/Other
Requires: %name = %version-%release

%description nettle
This Pike module provides access to libnettle functions.

%package krb5
Summary: Kerberos pike module
Group: Development/Other
Requires: %name = %version-%release

%description krb5
This Pike module provides access to kerberos functions.

%if_with pcre
%package pcre
Summary: pcre pike module
Group: Development/Other
Requires: %name = %version-%release

%description pcre
This Pike module provides access to libpcre functions.
%endif

%package math
Summary: fftw pike module
Group: Development/Other
Requires: %name = %version-%release

%description math
This Pike module provides access to fast fourier transform library functions.

%package perl
Summary: perl pike module
Group: Development/Other
Requires: %name = %version-%release

%description perl
This Pike module provides access to perl functions.

%add_findreq_skiplist %_libdir/pike/%version/modules/___Java.so

%package java
Summary: java pike module
Group: Development/Other
Requires: %name = %version-%release
Requires: java-1.6.0

%description java
This Pike module provides access to java.

%package devel
Summary: Devel pike files
Group: Development/Other
Requires: %name = %version-%release
Provides: pike-devel = %version-%release

%description devel
Header files for %name

%package doc
Summary: Devel pike docs
Group: Development/Other
Requires: %name = %version-%release
BuildArch: noarch

%description doc
%name documentaiton

%prep
%setup -n %tarname
tar -xf %SOURCE2

%patch0 -p0
%patch1 -p2
%patch2 -p1
%patch3 -p1

%build
export CPPFLAGS="-I%_includedir/krb5 -I%_includedir/freetype2 -I%_includedir/fuse -I%_includedir/pcre"
%make \
    CONFIGUREARGS=" \
	--without-_Ffmpeg \
	--without-rtldebug \
	--without-cdebug \
        --without-bundles \
        --without-copt \
        --disable-make_conf \
        --disable-noopty-retry \
	--with-ssleay \
	--with-bignums \
	--with-gmp \
	--with-poll \
	--with-zlib \
	--with-max-fd=65000 \
	--with-freetype \
	--with-gif \
	--with-jpeglib \
	--with-tifflib \
	--with-GLUT \
	--with-lib-GL \
	--with-GL \
	--with-sybase \
	--with-postgres \
	--with-postgres-include-dir=%_includedir/pgsql \
	--with-mysql \
        --with-crypt \
        --with-Bz2 \
        --with-fftw \
        --with-gdbm \
        --with-Kerberos \
	--with-perl \
        --with-MIME \
        %{?_with_pcre:--with-_Regexp_PCRE} \
        --with-SANE \
	--with-SDL=%_includedir/SDL \
	--with-SDL_mixer=%_includedir/SDL \
        --with-svg \
	--mandir=%_mandir \
	--prefix=%_prefix"

%make_build
# %make doc

%install
mkdir -p %buildroot%_altdir
cp -p pike%major-* %buildroot%_altdir

sed -i s/rm\(mod\+\"\.o\"\)\;/break\;/ bin/install.pike

%make \
        buildroot=%buildroot \
        prefix=%prefix \
        share_prefix=%_libdir/pike/%version \
        lib_prefix=%_libdir/pike/%version \
	INSTALLARGS=--traditional install

# prepare for alternatives
mv %buildroot%_bindir/pike %buildroot%_bindir/pike%major
mv %buildroot%_bindir/hilfe %buildroot%_bindir/hilfe%major
mv %buildroot%_bindir/rsif %buildroot%_bindir/rsif%major
mv %buildroot%_includedir/%oname %buildroot%_includedir/%name
mv %buildroot%_man1dir/%oname.1 %buildroot%_man1dir/%name.1

%__subst "s:/usr/local/bin/pike:%_bindir/%name:g" %buildroot%_bindir/hilfe%major
%__subst "s:/usr/local/bin/pike:%_bindir/%name:g" %buildroot%_bindir/rsif%major

mkdir -p %buildroot%_docdir/%name-%version
# cp -ap refdoc/traditional_manual %buildroot%_docdir/%name-%version/
tar -xf %SOURCE3 -C %buildroot%_docdir/%name-%version/

rm -rf %buildroot%prefix/doc
rm -f %buildroot/%moduledir/master.pike.in
rm -f %buildroot%_bindir/pike.syms
find %buildroot%_libdir/%oname -regex '.*\.o' -type f | xargs rm -f

pushd %buildroot/%moduledir
for file in `find ` ; do
#If this is a directory, then we need to NOT grab it recursively
  if [ -d $file ]; then
    file=`echo $file | sed -e 's|^\.|\%dir %moduledir|'`
  else
    %__subst "s:/usr/local/bin/pike:%_bindir/%oname:g" $file
    file=`echo $file | sed -e 's|^\.|%moduledir|'`
  fi
#conver the filename to lower case to make these matches
    lowercase=`echo $file | tr "[:upper:]" "[:lower:]"`
#This may be slower than "grep" alternatives, but it sure is a hell of a
#lot easier to read
    case "$lowercase" in
    *gdbm*)
        echo $file >> %_builddir/%tarname/files-%name-gdbm.list
        ;;
    *glu.*)
        echo $file >> %_builddir/%tarname/files-%name-glut.list
        ;;
    *glut*)
        echo $file >> %_builddir/%tarname/files-%name-glut.list
        ;;
    *gl.*)
        echo $file >> %_builddir/%tarname/files-%name-gl.list
        ;;
    *gtk*)
        echo $file >> %_builddir/%tarname/files-%name-gtk.list
        ;;
    *glue.*)
        echo $file >> %_builddir/%tarname/files-%name-gtk.list
        ;;
    *gz.*)
        echo $file >> %_builddir/%tarname/files-%name-zlib.list
        ;;
    *image*)
        echo $file >> %_builddir/%tarname/files-%name-image.list
        ;;
    *odbc*)
        echo $file >> %_builddir/%tarname/files-%name-odbc.list
        ;;
    *mysql*)
        echo $file >> %_builddir/%tarname/files-%name-mysql.list
        ;;
    *postgres*)
        echo $file >> %_builddir/%tarname/files-%name-postgres.list
        ;;
    *pgsql*)
        echo $file >> %_builddir/%tarname/files-%name-postgres.list
        ;;
    *bz2*)
        echo $file >> %_builddir/%tarname/files-%name-bzip2.list
        ;;
    *sdl*)
        echo $file >> %_builddir/%tarname/files-%name-sdl.list
        ;;
    *sane*)
        echo $file >> %_builddir/%tarname/files-%name-sane.list
        ;;
    *nettle*)
        echo $file >> %_builddir/%tarname/files-%name-nettle.list
        ;;
    *kerberos*)
        echo $file >> %_builddir/%tarname/files-%name-krb5.list
        ;;
    *pcre*)
        echo $file >> %_builddir/%tarname/files-%name-pcre.list
        ;;
    *math*)
        echo $file >> %_builddir/%tarname/files-%name-math.list
        ;;
    *perl*)
        echo $file >> %_builddir/%tarname/files-%name-perl.list
        ;;
    *java*)
        echo $file >> %_builddir/%tarname/files-%name-java.list
        ;;
    *)
        echo $file >> %_builddir/%tarname/files-%name.list
        ;;
    esac
done
popd

%files -f files-%name.list
%dir %_docdir/%name-%version
%_altdir/pike%major-hilfe
%_altdir/pike%major-pike
%_altdir/pike%major-rsif
%_altdir/pike%major-man1
%_bindir/hilfe%major
%_bindir/pike%major
%_bindir/rsif%major
%_man1dir/*
%moduledir/master.pike

%files devel
%_altdir/pike%major-include
%_includedir/pike%major

%files bzip2 -f files-%name-bzip2.list
%files gdbm  -f files-%name-gdbm.list
%files GLUT  -f files-%name-glut.list
%files GL    -f files-%name-gl.list
%files gtk   -f files-%name-gtk.list
%files zlib  -f files-%name-zlib.list
%files image -f files-%name-image.list
%files odbc  -f files-%name-odbc.list
%files mysql -f files-%name-mysql.list
%files postgres -f files-%name-postgres.list
%files sdl -f files-%name-sdl.list
%files sane -f files-%name-sane.list
%files nettle -f files-%name-nettle.list
%files krb5 -f files-%name-krb5.list
%if_with pcre
%files pcre -f files-%name-pcre.list
%endif
%files math -f files-%name-math.list
%files perl -f files-%name-perl.list
%files java -f files-%name-java.list

%files doc
%_docdir/%name-%version/traditional_manual

%changelog
* Sun Nov 07 2010 Vladimir Lettiev <crux@altlinux.ru> 7.6.112-alt4.1
- rebuilt with perl 5.12

* Sat Mar 13 2010 Boris Savelev <boris@altlinux.org> 7.6.112-alt4
- fix build (disable pcre)
- add patch from debian

* Sun May 10 2009 Boris Savelev <boris@altlinux.org> 7.6.112-alt3
- fix ALT#19984

* Mon Feb 16 2009 Boris Savelev <boris@altlinux.org> 7.6.112-alt2
- add new modules: krb5, pcre, math

* Sun Feb 15 2009 Boris Savelev <boris@altlinux.org> 7.6.112-alt1
- initial build for Sisyphus

* Mon Jan 20 2003 Tom Weber
- update to 7.2.440
- reenabled gtk module for RH8.0

* Thu Nov 07 2002 Tom Weber
- update to 7.2.426
- disabled the gtk module due to building problems on RH8.0

* Sat Oct 12 2002 Tom Weber
- update to 7.2.398
- removed the gmp subpackage

* Tue Aug  6 2002 Tom Weber <xrpm@4t2.com>
- fix a minor typo
- add test if pike's from CVS (Wim Bonis)

* Fri Jul 26 2002 Tom Weber <xrpm@4t2.com> 7.2.364
- adapted file list generation from Chris Petersen <xris@forevermore.net>

* Sun Mar 17 2002 Tom Weber <xrpm@4t2.com> 7.2.310
- use the crypto version
- turn off the odbc package

* Thu Mar 14 2002 Tom Weber <xrpm@4t2.com> 7.2.298
- stripped the changelog (this spec was derived from a spec from mandrakesoft
  but I changed a lot, thanks to Lenny Cartier for the original one)
